/*
 ============================================================================
 Name		 : Descriptors.cpp
 Copyright   : Symbian Academy, 2007
 Description : Exercise: Descriptors, Part 1
 ============================================================================
 */

//  Include Files  

#include <e32base.h>
#include <e32std.h>
#include <e32cons.h>            // Console

// Function prototype (C-style).
LOCAL_C void MainL();
GLDEF_C TInt E32Main();

//  Global Variables
LOCAL_D CConsoleBase* console;

LOCAL_C void MainL()
	{
	// ------------------------------------------------------------------
	// Initialization
	// ------------------------------------------------------------------

	// Edit 1: Create literal KString1 with text "My Text"
	
	// Edit 2: Create literal KString2 with text "Your Text"
	
	// Edit 3: Create literal KString3 with text "His Test" (teSt instead of teXt!!)
	
	
	// Edit 4: Create TBuf str1 with maximum length of 20, 
	//         initialize with contents of KString1
	
	// Edit 5: Create TBuf str2 with maximum length of 20,
	//         initialize with contents of KString2
	

	// Result variable that will save temp. results
	TInt result = 0;

	// ------------------------------------------------------------------
	// COMPARE
	// ------------------------------------------------------------------
	// Note: Result of Compare() is the same as strcmp() in C
	// Find help in S60 / UIQ SDK help: Search for TDesC16

	// Edit 6: Compare str1 and str2
	
	// Format output and print it to the console
	_LIT(KFormatCompare1, "Compare() using str1 and str2 = %d\n");
	console->Printf(KFormatCompare1, result);

	// Edit 7: Compare str1 and KString1 and print the output to the console
	



	// ------------------------------------------------------------------
	// FIND
	// ------------------------------------------------------------------
	_LIT(KFind1, "Text");

	// Edit 8: Find KFind1 in str1
	
	_LIT(KFormatFind1, "Find KFind1 in str1 = %d\n");
	console->Printf(KFormatFind1, result);

	// ------------------------------------------------------------------
	// MATCH
	// ------------------------------------------------------------------
	// Match allows to use wildcards:
	// * represents a sequence of characters
	// ? represents an occurence of any single character
	_LIT(KMatch1, "* Text");

	// Edit 9: Match str1 with KMatch1
	
	_LIT(KFormatMatch1, "Match str1 and KMatch1 = %d\n");
	console->Printf(KFormatMatch1, result);

	// ------------------------------------------------------------------
	// COPY
	// ------------------------------------------------------------------
	// Edit 10: Copy data from str1 to str2 (thus replacing the data
	//         currently stored in str2) and make it uppercase.
	//         Hint: Use CopyUC()
	
	// Print contents of str2
	_LIT(KFormatCopy1, "Copy + uppercase str1 into str2 = %S\n");
	// Edit 11: Uncomment the following line to print the results
	//console->Printf(KFormatCopy1, &str2);

	// ------------------------------------------------------------------
	// APPEND
	// ------------------------------------------------------------------
	// Edit 12: Append str1 to str2 and print contents of str2


	

	// ------------------------------------------------------------------
	// DELETE
	// ------------------------------------------------------------------
	// Edit 13: Delete data in str2 starting at position 3 with a length of 7
	//          and print the results


	

	}

// ------------------------------------------------------------------
// Main Application
// ------------------------------------------------------------------
GLDEF_C TInt E32Main()
	{
	// Create cleanup stack
	CTrapCleanup* cleanup = CTrapCleanup::New ();

	// Create output console
	_LIT(KTextConsoleTitle, "Console - Descriptors 1");
	TRAPD(createError, console = Console::NewL(KTextConsoleTitle, TSize(KConsFullScreen,KConsFullScreen)))
	;
	if ( createError)
		return createError;

	// Run application code inside TRAP harness
	__UHEAP_MARK;

	TRAPD(mainError, MainL())
	;
	_LIT(KTextFailed, "MainL() failed, leave code = %d\n");
	if ( mainError)
		{
		console->Printf (KTextFailed, mainError);
		}

	// Wait for the space key before exiting.
	// Generally better than accepting any key to prevent immediate shutdown
	// if a key has still been in the queue when the app. started.
	_LIT(KTextPressSpace, "\n[Press space to exit]\n");
	console->Printf (KTextPressSpace);
	while (console->Getch ()!= EKeySpace)
		{
		}

	// Check the state of the heap memory - if the same amount of memory
	// is available as before MainL() was executed, everything's fine.
	// Otherwise, a panic will be raised, which would result in a graphical
	// error dialog in an UI framework, but exits the application when
	// using the console mode.
	__UHEAP_MARKEND;

	// If the program passed the __UHEAP_MARKEND-macro, no memory
	// leaks were detected
	_LIT(KTextMemoryLeak, "\nNo memory leaks detected! [Press space]\n");
	console->Printf (KTextMemoryLeak);
	while (console->Getch ()!= EKeySpace)
		{
		}

	// Cleanup
	delete console;
	delete cleanup;
	return KErrNone;
	}
